#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/time.h>
#ifdef POSIX
#  include <sys/select.h>
#endif
#include <sys/resource.h>

/* note that this getdtablesize function only works if
   getrlimit() is definend and can return the maximum
   number of fd's.  Otherwise, we set the hard limit
   at 8192. */

#ifdef NO_GETDTABLSIZE
int 
getdtablesize() 
{
#ifdef RLIMIT_NOFILE
    FILE *array[8192];
    int count = 0;
    int i;

    for (i = 0; i<2048 ; i++) 
	array[i] = (FILE *) 0;
      
    do {
	array[count] = fopen("getmax.c","r");
	count++;
    } while (array[count - 1]);

    for (i = 0; i<count; i++)
	fclose(array[i]);

    count += 3 - 1;  /* for stdin, stdout and stderr */
	/* minus the one we couldn't open */
    return count;
#else
    struct rlimit maxdescs;

    getrlimit(RLIMIT_NOFILE, &maxdescs);

    return (int) maxdescs.rlim_cur;
#endif
}
#endif

#if !defined(_SEQUENT_)

int
setdtablesize(newfdmax)
    int newfdmax;
{
    struct rlimit maxdescs;

#ifdef RLIMIT_NOFILE
    getrlimit(RLIMIT_NOFILE, &maxdescs);
    maxdescs.rlim_cur = newfdmax;
    setrlimit(RLIMIT_NOFILE, &maxdescs);


    return (int) maxdescs.rlim_cur;
#else
    return getdtablesize();
#endif
}

#endif

int 
gettablesize()
{
    return getdtablesize();
}

int 
settablesize(size)
    size_t size;
{
    struct splayer *who;
    struct splayer *tmp;
    fd_set          fds;
    int             max;

    max = setfds(&fds);

    if (size < max) 
	size = max;

    return setdtablesize(size);
}

