/* security.c 

  Routines for supporting haven adminstration.

 Chris Eleveld      (The Insane Hermit)
 Robert Slaven      (The Celestial Knight/Tigger)
 Jerry Bolton, Jr.  (Creel)
 Dave Mott          (Energizer Rabbit)

*/

#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#ifdef POSIX
#  include <sys/select.h>
#endif
#include <sys/resource.h>

#if defined (BSD) || defined (STRICT_BSD)
#  include <strings.h>
#else
#include <string.h>
#endif

#include "lorien.h"


/* .shutdown is available to level 4 and higher. */
#include "security.h"

char sendbuf[OBUFSIZE];
extern int die();

void
init_read_powerfile()
{
    FILE *pfile;
    char *tmp;
    char  s[BUFSIZE];
    int index = 0;

    pfile = fopen("lorien.power","r");
    if (pfile) {
	while (!feof(pfile) && index != (NUMLVL + 1)) {
	    fgets(s,BUFSIZE - 1,pfile);
	    if (!feof(pfile)) {
		if (tmp = (char *) strstr(s,"\r"))
		    *tmp = (char) 0;
		if (tmp = (char *) strstr(s,"\n"))
		    *tmp = (char) 0;
		strncpy(passwds[index],s,MAX_POWER_PASS);
		index++;
	    }
	}
	fclose(pfile);
    }
}

int
printlevels(pplayer)
    struct splayer *pplayer;
{
    int i;
   
    sprintf(sendbuf,">> The passwords are as follows:\r\n");
    sendtoplayer(pplayer,sendbuf);
    for (i = 0; i < NUMLVL; i++) {
	sprintf(sendbuf,">> Level %d: %s\r\n",i,passwds[i]);
	if (i <= pplayer->seclevel)
	    sendtoplayer(pplayer,sendbuf);
    }
    sprintf(sendbuf,">> Shutdown: %s\r\n",P_SHUTDOWN);
    sendtoplayer(pplayer,sendbuf);
    return 1;
}

int
haven_shutdown(pplayer)
    struct splayer *pplayer;
{
    sprintf(sendbuf, "Shutting down to shut down command by %s from %s.\n",
	    pplayer->name, pplayer->host);
    log_msg(sendbuf);
    sprintf(sendbuf, ">> Shutting down to shut down command by %s from %s.\r\n",
	    pplayer->name, pplayer->host);
    sendall(sendbuf, ALL,0);
    die(0);
}

int 
changelevel(password, pplayer)
    char *password;
    struct splayer *pplayer;
{
    char *buf;
    int level;

	/* check for returns and newlines */
    if ((buf = (char *) index(password, '\r')) != (char *)0) {
	*buf = '\000';
    }

    if ((buf = (char *) index(password, '\n')) != (char *)0) {
	*buf = '\000';
    }

	/* if there is an '=' it is a password change.  old password in password
	   new password in buf.  '=' discarded. */

    if ((buf = (char *) index(password, '=')) != (char *)0) {
	*buf = '\000';
	buf++;
    }

    if (!strcmp(password, P_FLUSH_ERR)) {
	(void) fflush(stderr);
	level = pplayer->seclevel;
	return level;
    }
    
    if (!strcmp(password, P_SHUTDOWN)) {
	haven_shutdown(pplayer);
    }
	/* compare to each successive password if not a command, or if changing.
	   if not valid, then set level to -1.  this will kick them off. */
    
    for (level = JOEUSER;level < NUMLVL;level++)
	if (!strcmp(password, passwds[level]))
	    break;

    if (level == NUMLVL) 
	level = -1;

	/* if buf is neither null nor empty, then it is a password change.
	   player must be at least level 4 for this.  */

    if ((buf != (char *)0) && (*buf != '\000')) {
	if (pplayer->seclevel < SUPREME)
	    return -1;

	sprintf(sendbuf, "%s changed level %d passwd, %s, to %s.",
		pplayer->name, level, passwds[level], buf);
	strncpy(passwds[level], buf, MAX_POWER_PASS);
	log_msg(sendbuf);
        sprintf(sendbuf, ">> Level %d password changed to %s.\r\n", level, passwds[level]);
        sendtoplayer(pplayer, sendbuf);
	level = pplayer->seclevel;
    }
    else {
        sprintf(sendbuf, ">> Level changed to %d.\r\n", level);
        if (level != -1) sendtoplayer(pplayer, sendbuf);
    };

    if (*password != '\000') {
	if (level == -1) {
	    sprintf(sendbuf, "failed passwd attempt -->%s<-- by %s", password,
		    pplayer->name);
	    log_msg(sendbuf);
	}
    }
    return(level);
}

